varying vec2 v_texCoord;
varying vec2 v;
uniform vec2 center;
uniform int isGray;
uniform float rad;
uniform sampler2D tex;
uniform float r;
uniform float g;
uniform float b;
uniform float xAdd;
uniform float yAdd;
void main()
{
	vec4 DiffuseColor = texture2D(CC_Texture0,v_texCoord);
	vec2 pos1 = v - center;
	vec2 pos2;
	pos2.x = 0.500;
	pos2.y = 0.500;
	pos2.x += pos1.x * xAdd;
	pos2.y = pos2.y - pos1.y * yAdd;
	float grey = dot(texture2D(CC_Texture0, v_texCoord).rgb, vec3(0.299, 0.587, 0.114));
	if(pos2.x >= 0.0 &&pos2.x <= 1.0 && pos2.y >= 0.0 &&pos2.y <= 1.0)
	{
		vec4 color = texture2D(tex,pos2);
		
		if(abs(color.r - r) < 0.001 &&abs(color.g - g) < 0.001 && abs(color.b - b)< 0.001)
		{
			
		}
		else
		{
			DiffuseColor = color;
			grey = dot(texture2D(tex, pos2).rgb, vec3(0.299, 0.587, 0.114));
	//		DiffuseColor = texture2D(CC_Texture0,v_texCoord);
			
		}
		if(isGray == 1)
		{
			DiffuseColor.r = grey;
			DiffuseColor.g = grey;
			DiffuseColor.b = grey;
		}
	}
	else
	{
		DiffuseColor.r = 0.0;
		DiffuseColor.g = 0.0;
		DiffuseColor.b = 0.0;
	    DiffuseColor.a = 0.0;
	}
	gl_FragColor = DiffuseColor;
}